local GUI_functions = require ("GUI_functions")
require("toCSV")
--require ("CreativeChests")

function try_init(player_index)
	game.players[player_index].print('GUI added with "try_init" function')
	global.GUI = global.GUI or {}
	global.GUI[player_index] = global.GUI[player_index] or {}
	global.GUI[player_index].enabled = false
	global.GUI[player_index].position = {old = {x=0, y=0}}
	global.GUI[player_index].speed = {old = 0, on_tick = 0}
	global.GUI[player_index].acceleration = {old = 0, on_tick = 0}
	global.GUI[player_index].recording = {enabled = false, tabl = {}, saved = false}

end

script.on_event(defines.events.on_player_created, function (event)
	local player_index = event.player_index
	try_init(player_index)
end)

function if_player_in_car(player_index)
	local player = game.players[player_index]
	if player ~= nil and player.connected then -- need a "player.connected" from 0.13
		if player.character then 
			if player.character.vehicle then	
					return true
			end
		end
	end
	return false
end

script.on_event(defines.events.on_player_driving_changed_state, function (event)
	local player_index = event.player_index
	if if_player_in_car(player_index) then
		GUI_functions.make_gui(player_index)
	else
		GUI_functions.delete_gui(player_index)
	end
end)


function vector_diff (position_old, position_new)
	local diff = ((position_old.x - position_new.x)^2 + (position_old.y - position_new.y)^2)^0.5
	--game.players[1].print('diff = ' .. diff)
	return diff
end

function dx_pro_dy (dx, dy)
	return dx/dy*60
end

function save_to_file_table (tabl, file_name, player_index)
	local s = toCSV (tabl)
	local filename = 'CarSpeed/'.. player_index .. '_' .. file_name ..'.csv'
	game.write_file(filename, s, false, player_index)
end

function recording (player_index)
	if global.GUI[player_index].recording.enabled then
		local tabl = global.GUI[player_index].recording.tabl
		tabl[game.tick] = {tick = game.tick, x = game.players[player_index].position.x, y = game.players[player_index].position.y}
		global.GUI[player_index].recording.saved = false
	else	
		if not(global.GUI[player_index].recording.saved) then
			local tabl = global.GUI[player_index].recording.tabl
			save_to_file_table (tabl, game.tick, player_index)
			global.GUI[player_index].recording.enabled = false
			global.GUI[player_index].recording.saved = true
			global.GUI[player_index].recording.tabl = {}
		end
	end
end

script.on_event(defines.events.on_tick, function (event)
	local players = game.players
	local discret = 1
	local tick = game.tick
	if not ((tick % discret) == 0) then return end
	for player_index, player in pairs (players) do
		 recording (player_index)
		if global.GUI[player_index].enabled then
			local car = global.GUI[player_index]
			local position_old = car.position.old
			local position_new = game.players[player_index].position

			local speed_old = car.speed.old + 0
			local speed_new = dx_pro_dy(vector_diff(position_old, position_new), tick - car.speed.on_tick) -- from tiles/tick to tiles/sec
			car.position.old = position_new
			car.speed.on_tick = tick
			car.speed.old = speed_new
			
			if not (speed_old == speed_new) then
				local acceleration_old = car.acceleration.old
				local acceleration_new = dx_pro_dy(speed_new - speed_old, tick - car.acceleration.on_tick)
				car.acceleration.old = acceleration_new
				car.acceleration.on_tick = tick
				if not (acceleration_old == acceleration_new) then
					GUI_functions.make_gui (player_index)
				end
			end
		end
	end
end)

script.on_event(defines.events.on_gui_click, function (event)
	local player_index = event.player_index
	game.players[player_index].print(event.element.name)
	if event.element.name == "cs_update" then 
		GUI_functions.make_gui (player_index)
	end
	if event.element.name == "cs_start" then 
		global.GUI[player_index].recording.enabled = true
	end
	if event.element.name == "cs_stop" then 
		global.GUI[player_index].recording.enabled = false
	end
end)


