
-- Used to escape "'s by toCSV
function escapeCSV (s)
	if not (s) then return "nil" end
	if string.find(s, '[,"]') then
		-- string.gsub(s, pattern, replace [, n])
		s = '"' .. string.gsub(s, '"', '""') .. '"'
	end
	return s
end


function toCSV (tabl)
	if not tabl then
		log("toCSV: tabl is not exist")
		return "error CSV 00"
	end

	if not (type(tabl)=="table") then
		log("toCSV: tabl is not table")
		return "error CSV 01"
	end
	
	local players = {}
	local n = 0
	local existing_index = nil
	
	for i,p in pairs(tabl) do
		existing_index = i
		n = n + 1
		players[n] = i
	end
	
	if not (#players > 0) then
		log("toCSV: there is no players")
		return "error CSV 02"
	end


	local head = {}

	n = 0

	for i,p in pairs(tabl[existing_index]) do
		n = n + 1
		head[n] = i
	end
	if not (#head > 0) then
		log("toCSV: there is no head")
		return "error CSV 03"
	end
	local s = ""
	-- write head of table to string
	for i, p in pairs(head) do  
		s = s .. "," .. escapeCSV(p)
	end

	
	-- new string
	s = s .. "\n"

	for player_index, p1ayer in pairs(tabl) do
	-- empty cell
	s = s .. ","
		for index, parameter in pairs(head) do
			local text = tabl[player_index][parameter]
			
			if type(text) == "table" then
				s = s .. tablToString(text)
			elseif type(text) == "boolean" then
				s = s .. boolToString(text)
			elseif type(text) == "userdata" then
				s = s .. "userdata"
			else
				s = s .. escapeCSV(text) 
			end
			s = s .. ","
		end
		-- new string
		s = s .. "\n"
	end
	return s
end

function tablToString(tabl)
local strng = "|"
	for i, p in pairs (tabl) do
		
		if type(p)=="table" then
			tablToString(tabl)
			else
			strng = strng .. i .. "=" .. p .. "|"
		end
	end
return strng
end

function boolToString(bool)
local strng = "false"
	if bool then strng = "true" end
return strng
end
